package rahmen;
import java.util.*;

/**
 * Referenziert die einzelnen Bauteile, die ein Rahmen beinhaltet.
 * Hier werden die Eigenschaften gesammelt, ber die alle Bauteile
 * verfgen
 */
public abstract class Bauteile {
  /* {author=Johannes Hhne}*/

    /**
     * Flchentrgheit des Bauteils fr die Berechnung der Schnittgren
     * und die Bestimmung der Durchbiegung. 
     */
    private double i_y = 0.0;
    void setI_y(double i_y){this.i_y = i_y;}
    double getI_y(){return i_y;}

    /**
     * Neigung des jeweiligen Bauteils in [rad]
     */
    private double neigung = Math.PI/2.0;

    /**
     * E-Modul des Materials in [N/mm^2] = [MN/m^2]
     */
    private double e;
    void setE(double e){this.e = e;}

    double getNeigung(){return neigung;}

	void setNeigung(double neigung){this.neigung = neigung;}

    double getE(){return e;}

    /**
     * Lnge des jeweiligen Bauteils 
     */
    private double laenge;
	void setLaenge(double laenge){this.laenge = laenge;}
    double getLaenge(){return laenge;}
}
