package rahmen;
import java.util.*;
import java.io.Serializable;

/**Verfeinert die Art des Rahmens. Der rechte Stiel ist mit dem Riegel gelenkig verbunde */
public final class Rahmen_I extends Rahmen {
  /* {author=Johannes Hhne}*/

    /**
    *   @element-type <{Bauteile}>
    * @stereotype constructor
    */
    Rahmen_I(double h_links, double h_rechts, double breite, double h_keller, double abstand) {
        super(h_links, h_rechts, breite, h_keller, abstand);
    }

    void schneiden() {
        accept(new Schnitt_I());
    }

    void accept(Schnittgroessen visitor){
            visitor.visitRahmen(this);
        }
}
