package rahmen;
import java.util.*;

/**
 * Schneelast als Linienlast
 * @author Johannes Hhne
 */
class Schnee {

    /**
     * Schneelastzone des Gebudes.
     * Gltige Werte sind "I", "II", "III" oder "IV"
     */
  	private String zone = new String();
  	void setZone(String zone){this.zone = zone;}
  	String getZone(){return zone;}

    /**
     * Gelndehhe in [m]
     */
	private int gelHoehe = 0;
    void setGelHoehe(int gelHoehe){this.gelHoehe = gelHoehe;}
    int getGelHoehe(){return gelHoehe;}

    /**
     * Liefert die Schneelast in [MN/m] diese Methode rechnet vorerst immer
     * mit einer Regelschneelast von 0.00075MN/m die Tabelle wird spter
     * implementiert
     * @param abstand - Abstand der Rahmen untereinander in [m]
     * @return Schneelast in [MN/m]
     */
    double getS(double abstand){
        return (1.5*0.00075*abstand);
    }
}
