package rahmen;
import java.util.*;

/**
 * Schnittgren fr Ramen I
 * @author Johannes Hhne
 * geprft und fr gut befunden
 */
final class Schnitt_I implements Schnittgroessen {

    //Globale Gren
	private double l12 = 0.0;
    private double E12 = 0.0;
    private double I12 = 0.0;

    private double l23 = 0.0;
    private double E23 = 0.0;
    private double I23 = 0.0;

    private double l34 = 0.0;
    private double E34 = 0.0;
    private double I34 = 0.0;

    private double l45 = 0.0;
    private double E45 = 0.0;
    private double I45 = 0.0;

    private double b = 0.0;

	//Abkrzungen fr Lngen
    private double cl = 0.0;
    private double cr = 0.0;
    private double h3 = 0.0;

    //Eigengewichte
    private double gStlinks = 0.0;
    private double gStrechts = 0.0;
    private double gRg = 0.0;

    //Erdlasten
    private double eah = 0.0;
    private double eahp = 0.0;

    //Windkrfte
    private double wsog = 0.0;
    private double wld0_8 = 0.0;
    private double wld8_20 = 0.0;
    private double wrs0_8 = 0.0;
    private double wrs8_20 = 0.0;
    private double wls0_8 = 0.0;
    private double wls8_20 = 0.0;
    private double wrd0_8 = 0.0;
    private double wrd8_20 = 0.0;

    //Schneelast
    private double sd = 0.0;


    //Teilmomente des Nullzustndes
    private double M210_e_ah = 0.0;
    private double M210_e_ahp = 0.0;

    private double M230_w_links_Druck = 0.0;
    private double M230_w_rechts_Sog = 0.0;

    private double M320_w_links_Druck = 0.0;
    private double M320_w_rechts_Sog = 0.0;

    private double M340_s = 0.0;
    private double M340_w_Sog = 0.0;
    private double M340_g_Rg = 0.0;

    private double M430_s = 0.0;
    private double M430_w_Sog = 0.0;
    private double M430_g_Rg = 0.0;

    private double M450_w_links_Sog = 0.0;
    private double M450_w_rechts_Druck = 0.0;
    private Rahmen rahm = null;

    //Momente im Null-Zustand
    private double M210 = 0.0;
    private double M230 = 0.0;

    private double M320 = 0.0;
    private double M340 = 0.0;

    private double M430 = 0.0;
    private double M450 = 0.0;

    //Momente im Eins-Zustand
    private double M211 = 0.0;
    private double M231 = 0.0;

    private double M321 = 0.0;

	//Momente im Zwei-Zustand
    private double M232 = 0.0;

    private double M322 = 0.0;

    private double M452 = 0.0;

    //Momente im Drei-Zustand
    private double M233 = 0.0;

    private double M323 = 0.0;
    private double M343 = 0.0;

    private double M433 = 0.0;

    //Momente im Vier-Zustand
	private double M344 = 0.0;

    private double M434 = 0.0;
    private double M454 = 0.0;

    //Fesselkrfte
    private double Z10  = 0.0;
    private double Z11  = 0.0;
    private double Z12  = 0.0;
    private double Z13  = 0.0;
    private double Z14  = 0.0;

    private double Z20  = 0.0;
    private double Z21  = 0.0;
    private double Z22  = 0.0;
    private double Z23  = 0.0;
    private double Z24  = 0.0;

    private double Z30  = 0.0;
    private double Z31  = 0.0;
    private double Z32  = 0.0;
    private double Z33  = 0.0;
    private double Z34  = 0.0;

    private double Z40  = 0.0;
    private double Z41  = 0.0;
    private double Z42  = 0.0;
    private double Z43  = 0.0;
    private double Z44  = 0.0;

    //Verformungen der Fesseln
    private double Y1 = 0.0;
    private double Y2 = 0.0;
    private double Y3 = 0.0;
    private double Y4 = 0.0;


    public void visitRahmen(Rahmen Element){
		//Nur Rahmen der Klasse Rahmen_I sollen behandelt werden
        if(!(Element instanceof Rahmen_I)){
            System.out.println("Diese Klasse eignet sich nur fr Objekte der Klasse Rahmen_I");
            return;
        }

        //Rahmen berschreiben
        this.rahm = Element;

		l12 = rahm.getKeller().getLaenge();
        E12 = rahm.getKeller().getE();
        I12 = rahm.getKeller().getI_y();

        l23 = rahm.getLinkerStiel().getLaenge();
        E23 = rahm.getLinkerStiel().getE();
        I23 = rahm.getLinkerStiel().getI_y();

        l34 = rahm.getRiegel().getLaenge();
        E34 = rahm.getRiegel().getE();
        I34 = rahm.getRiegel().getI_y();

        l45 = rahm.getRechterStiel().getLaenge();
        E45 = rahm.getRechterStiel().getE();
        I45 = rahm.getRechterStiel().getI_y();

        b = rahm.getBreite();

        //Abkrzungen fr Lngen
        //Wenn die Stiele nicht 8m hoch sind, wird dieser Anteil durch cl = 0 zerstrt
        cl = l23-8 > 0 ? l23-8  : 0.0 ;
        cr = l45-8 > 0 ? l45-8  : 0.0 ;
        h3 = l45-l23;

        //Eigengewichte
        gStlinks = rahm.getEigengewicht().getGlinks(rahm.getAbstand() , l12+l23);
        gStrechts = rahm.getEigengewicht().getGrechts(rahm.getAbstand() , l45);
        gRg = rahm.getEigengewicht().getDach(rahm.getAbstand(),rahm.getRiegel().getNeigung());

        //Windlasten
        //Es mu geprft werden, ob das Dach ber 8m liegt oder nicht
        wsog = (rahm.getLinkerStiel().getLaenge()>=8 || rahm.getRechterStiel().getLaenge()>8 ?
                rahm.getWindlast().getSogDach8_20(rahm.getAbstand()) :
                rahm.getWindlast().getSogDach8_20(rahm.getAbstand()));
        wld0_8 = rahm.getWindlast().getDruck0_8(rahm.getAbstand());
        wld8_20 = rahm.getWindlast().getDruck8_20(rahm.getAbstand());
        wrs0_8 = rahm.getWindlast().getSog0_8(rahm.getAbstand());
        wrs8_20 = rahm.getWindlast().getSog8_20(rahm.getAbstand());
        wls0_8 = rahm.getWindlast().getSog0_8(rahm.getAbstand());
        wls8_20 = rahm.getWindlast().getSog8_20(rahm.getAbstand());
        wrd0_8 = rahm.getWindlast().getDruck0_8(rahm.getAbstand());
        wrd8_20 = rahm.getWindlast().getDruck8_20(rahm.getAbstand());

        //Erdlasten
        eah = rahm.getErddruck().getGErd(l12);
        eahp = rahm.getErddruck().getPErd(l12);

		//Schneelast
        sd = rahm.getSchneeLast().getS(rahm.getAbstand());


        //Einzelkomponenten des Null-Zustandes bestimmen
        setNullKomponeneten();

        //Momente der N-Zustnde bestimmen
        setNZustand();

        //Fesselkrfte der N-Zustnde bestimmen
        setFesselNZustand();

        //Grundkombination 1a
        setGK_Ia();

        //Grundkombination 1b
        setGK_Ib();

        //Grundkombination 1c
        setGK_Ic();

        //Grundkombination 1c
        setGK_Id();

        //Grundkombination IIa
        setGK_IIa();

        //Grundkombination IIb
        setGK_IIb();


    }

    /**
     * Diese Methode errechnet aus den einzelnen einwirkenden Lasten
     * die Momente im Grundzustand aus denen dann ja nach Lastfall der
     * Nullzustand gebaut werden soll
     * geprft und fr gut befunden
     */
    private void setNullKomponeneten(){
        M210_e_ah = -7*eah*l12*l12/120;
        M210_e_ahp = -eahp*l12*l12/8;

        M230_w_links_Druck = -wld0_8*l23*l23/12 - (wld8_20-wld0_8)*cl*cl*cl/l23*(1.0/3.0-1.0/4.0*cl/l23);
        M230_w_rechts_Sog = wrs0_8*l23*l23/12 + (wrs8_20-wrs0_8)*cl*cl*cl/l23*(1.0/3.0-1.0/4.0*cl/l23);
        M320_w_links_Druck = -wld0_8*l23*l23/12 - (wld8_20-wld0_8)*cl*cl*(1.0/2.0-2.0/3.0*cl/l23+1.0/4.0*cl*cl/l23/l23);
        M320_w_rechts_Sog = wrs0_8*l23*l23/12 + (wrs8_20-wrs0_8)*cl*cl*(1.0/2.0-2.0/3.0*cl/l23+1.0/4.0*cl*cl/l23/l23);

        M340_s = -sd*b*b/12;
		M340_w_Sog = wsog*l34*l34/12;
		M340_g_Rg = -gRg*b*b/12;

        M430_s = M340_s;
        M430_w_Sog = M340_w_Sog;
        M430_g_Rg = M340_g_Rg;

        M450_w_links_Sog = wls0_8*l45*l45/8 + (wls8_20-wls0_8)*cr*cr*1.0/8.0*(2.0-cr/l45)*(2.0-cr/l45);
        M450_w_rechts_Druck = -wrd0_8*l45*l45/8 - (wrd8_20-wrd0_8)*cr*cr*1.0/8.0*(2.0-cr/l45)*(2.0-cr/l45);

    }

	/**
     * Erzeugt die N-Zustnde nach Th I. Ordnung
     * geprft und fr gut befunden
     */
    private void setNZustand(){

        //Eins-Zustand
        M211 = -3.0*E12*I12/l12;
        M231 = 4.0*E23*I23/l23;
		M321 = -2.0*E23*I23/l23;

        //Zwei-Zustand
		M232 = -6.0*E23*I23/l23/l23;

        M322 = 6.0*E23*I23/l23/l23;

        M452 = -3.0*E45*I45/l45/l45;

        //Drei-Zustand
		M233 = 2.0*E23*I23/l23;

        M323 = -4.0*E23*I23/l23;
        M343 = 4.0*E34*I34/l34;

        M433 = -2.0*E34*I34/l34;

        //Vier-Zustand
		M344 = 2.0*E34*I34/l34;

        M434 = -4.0*E34*I34/l34;
		M454 = 3.0*E45*I45/l45;
    }

    /**
     * Die Fesselkrfte aus den N-zustnden besimmen
     * geprft und fr gut befunden
     */
    private void setFesselNZustand(){

        Z11 = M231-M211;
        Z12 = M232;
        Z13 = M233;
        Z14 = 0.0;

        Z21 = (M321-M231)/l23;
        Z22 = (M322-M232)/l23 - M452/l45;
        Z23 = (M323-M233)/l23;
        Z24 = -M454/l45;

        Z31 = -M321;
        Z32 = -M322;
        Z33 = M343 - M323;
        Z34 = M344;

        Z41 = 0.0;
        Z42 = M452;
        Z43 = -M433;
        Z44 = M454 - M434;
    }

	/**
     * Cramersche Regel zum Lsen eines 4x4 Gleichungssystems
     */
	private void setCramer(){
        double D     =  det4x4(new double[][]{{Z11 , Z12 , Z13 , Z14 },
          								      {Z21 , Z22 , Z23 , Z24 },
          								      {Z31 , Z32 , Z33 , Z34 },
          								      {Z41 , Z42 , Z43 , Z44 }});

        double D1     = det4x4(new double[][]{{-Z10 , Z12 , Z13 , Z14 },
          								      {-Z20 , Z22 , Z23 , Z24 },
          								      {-Z30 , Z32 , Z33 , Z34 },
          								      {-Z40 , Z42 , Z43 , Z44 }});

        double D2     = det4x4(new double[][]{{Z11 , -Z10 , Z13 , Z14 },
          								      {Z21 , -Z20 , Z23 , Z24 },
          								      {Z31 , -Z30 , Z33 , Z34 },
          								      {Z41 , -Z40 , Z43 , Z44 }});

        double D3     = det4x4(new double[][]{{Z11 , Z12 , -Z10 , Z14 },
          								      {Z21 , Z22 , -Z20 , Z24 },
          								      {Z31 , Z32 , -Z30 , Z34 },
          								      {Z41 , Z42 , -Z40 , Z44 }});

        double D4     = det4x4(new double[][]{{Z11 , Z12 , Z13 , -Z10 },
          								      {Z21 , Z22 , Z23 , -Z20 },
          								      {Z31 , Z32 , Z33 , -Z30 },
          								      {Z41 , Z42 , Z43 , -Z40 }});
        Y1 = D1/D;
        Y2 = D2/D;
        Y3 = D3/D;
        Y4 = D4/D;
    }


	/**
	 * Errechnet mit Sarrus die Determinante einer 3x3 Matrix
	 */
	private double det3x3(double[][] d){
		double det = d[0][0]*d[1][1]*d[2][2] +
					 d[0][1]*d[1][2]*d[2][0] +
					 d[0][2]*d[1][0]*d[2][1] -
					 d[2][0]*d[1][1]*d[0][2] -
					 d[2][1]*d[1][2]*d[0][0] -
					 d[2][2]*d[1][0]*d[0][1];
		return det;
	}

	/**
	 * Errechnet die Determinante einer 4x4 Matrix
	 */
	private double det4x4(double[][] d){
		double det = d[0][0]*det3x3(new double[][] {{d[1][1] , d[1][2] , d[1][3]},
													{d[2][1] , d[2][2] , d[2][3]},
													{d[3][1] , d[3][2] , d[3][3]}}) -
					 d[0][1]*det3x3(new double[][] {{d[1][0] , d[1][2] , d[1][3]},
													{d[2][0] , d[2][2] , d[2][3]},
													{d[3][0] , d[3][2] , d[3][3]}}) +
					 d[0][2]*det3x3(new double[][] {{d[1][0] , d[1][1] , d[1][3]},
													{d[2][0] , d[2][1] , d[2][3]},
													{d[3][0] , d[3][1] , d[3][3]}}) -
					 d[0][3]*det3x3(new double[][] {{d[1][0] , d[1][1] , d[1][2]},
													{d[2][0] , d[2][1] , d[2][2]},
													{d[3][0] , d[3][1] , d[3][2]}});
		return det;
	}

    /**
     * Grundkombination Ia laut Dokumentation
     * Methode ist nur fr diese Kombination geeignet
     */
    private void setGK_Ia(){
        //Verschiebung aus der Imperfektion des Bauwerks
        double Yimp = 0.0025*Math.sqrt(5.0/Math.max(l12+l23 , l45))*
                      0.5*(1.0+0.7071067812) * Math.max(l12+l23 , l45);

        //Einwirkungen aus den Nullzustnden
        double w1r = 0.0;
        double w2r = 0.0;
        double w1l = 0.0;
        double w2l = 0.0;
        double q34 = gRg+sd;
        double ws  = 0.0;
        eahp = 0;

		//Momente aus dem Null-Zustand
        M210 = M210_e_ah;
        M230 = 0.0;

        M320 = 0.0;
		M340 = M340_g_Rg + M340_s;

        M430 = M430_g_Rg + M430_s;
        M450 = 0.0;


        //Fesselkrfte aus dem Null-Zustand
		Z10 = M230-M210;
        Z20 = -M230/l23 + M320/l23 - M450/l45;
        Z30 = M340-M320;
        Z40 = M450-M430;

        /**
         * Hier begint die
         * Iteration ber die rechte Seite
         */
        //Deltaschranke fr die Iterationsschritte und der alte Wert
        double delta = 1.0;
		double Yalt = 0.0;
        //Schleife ber die einzelnen Iterationen bis zu einer Abweichung von
        //weniger als 1%
        do{
			Yalt = Y2;
            setCramer();
            Yimp = Y2 >= 0 ? Math.abs(Yimp) : Math.abs(Yimp)*(-1.0);

            //Ntige Schnittkrfte bestimmen
            double M22 = M210 + M211*Y1;
            double N12 = M22/b - gStlinks - q34*b/2;
			double N45 = -N12-gStlinks-gStrechts-q34*b;

			//fiktive Krfte
			double f23fikt = N12*(Y2+Yimp)/l23;
			double f45fikt = N45*(Y2+Yimp)/l45;

			//Neue Fesselkraft
        	Z20 = -M230/l23 + M320/l23 - M450/l45 + f23fikt + f45fikt;

            delta = (Y2-Yalt)/Yalt;
        }while(false);//delta > 0.001);

        //Schnittkrfte errechnen
		double M34_ = - ws*h3*h3/8
                      + (q34)*b*b/8;
        double M45_ = w2r !=0 && w1r != 0 ?
                        w2r*cr*(cr/2 + (0.5*l45 - w2r+w1r*cr)*(0.5*cr/l45-1))
                      + w1r*0.5*(l45*(0.5*l45 - w2r/w1r*cr) - (0.5*l45 - w2r/w1r*cr)*(0.5*l45 - w2r/w1r*cr)) :
                      0.0;

        double M22 = M210 + M211*Y1;
        double M33 = M320 + M321*Y1 + M322*Y2 + M323*Y3;
        double M44 = M450 +           M452*Y2           + M454*Y4;
		double M34 = M34_ + M33/2.0 + M44/2.0;
        double M45 = w1r != 0.0 ? M45_ + M44/l45*(l45/2.0 + w2r*cr/w1r) :
                                  M45_ + M44/l45*(l45/2.0);

        double N12 = M22/b - gStlinks
                        + (w1l*l23*l23
                           + w2l*(l23*l23-64)
                           - w1r*l45*l45
                           - w2r*(l45*l45-64)
                           - ws*(l45*l45-h3*h3)
                           - q34*b*b)/(2*b);
		double N45 = -N12-gStlinks-gStrechts-q34*b;
        double N43 = Math.cos(rahm.getRiegel().getNeigung())
                      * (M44/l45 - 0.5/l45*(w1r*l45*l45 + w2r*(l45*l45-64)))
                      - Math.sin(rahm.getRiegel().getNeigung())
                      * (N45 + gStrechts);
        double N34 =   N43
                     - Math.cos(rahm.getRiegel().getNeigung())*ws*h3
                     - Math.sin(rahm.getRiegel().getNeigung())*q34*b;

        double Q11  = M22/l12 + eahp*l12/2.0 + eah*l12/3.0;
        double Q22u = Q11 - eahp*l12 - eah*l12/2.0;
        double Q22o = M33/l23 - M22/l23 + w1l*l23/2.0 + w2l*cl/2.0;
        double Q238 = Q22o + w1l*8;
        double Q33u = Q238 + (w1l + w2l)*cl;
        double Q33o =   Q33u * Math.sin(rahm.getRiegel().getNeigung())
                      - (N12+gStlinks)  * Math.cos(rahm.getRiegel().getNeigung());
        double Q44o = Q33o + ws*l34
                      - q34*b*Math.cos(rahm.getRiegel().getNeigung());
        double Q55  = -M44/l45 - w1r*l45/2.0 - w2r*cr/2.0;
        double Q458 = Q55 + w1r*8;
        double Q44u = Q458 + (w1r + w2r)*cr;

        //Ergebnisse in die Vektoren eintragen (sthn)
        rahm.getKeller().setM22(0 , M22);
        rahm.getKeller().setN12(0 , N12);
        rahm.getKeller().setQ11(0 , Q11);
        rahm.getKeller().setQ22u(0 , Q22u);

        rahm.getLinkerStiel().setM22(0 , M22);
        rahm.getLinkerStiel().setM33(0 , M33);
        rahm.getLinkerStiel().setN12(0 , N12);
        rahm.getLinkerStiel().setQ22o(0 , Q22o);
        rahm.getLinkerStiel().setQ238m(0 , Q238);
        rahm.getLinkerStiel().setQ33u(0 , Q33u);

        rahm.getRiegel().setM33(0 , M33);
        rahm.getRiegel().setM34(0 , M34);
        rahm.getRiegel().setM44(0 , M44);
        rahm.getRiegel().setN34(0 , N34);
        rahm.getRiegel().setN43(0 , N43);
        rahm.getRiegel().setQ33o(0 , Q33o);
        rahm.getRiegel().setQ44o(0 , Q44o);

        rahm.getRechterStiel().setM44(0 , M44);
        rahm.getRechterStiel().setM45(0 , M45);
        rahm.getRechterStiel().setN45(0 , N45);
        rahm.getRechterStiel().setQ44u(0 , Q44u);
        rahm.getRechterStiel().setQ458m(0 , Q458);
        rahm.getRechterStiel().setQ55(0 , Q55);

		//Verdrehungen eintragen
		rahm.setY1(0 , Y1);
		rahm.setY2(0 , Y2);
		rahm.setY3(0 , Y3);
		rahm.setY4(0 , Y4);
	}

    /**
     * Grundkombination Ib laut Dokumentation
     */
    private void setGK_Ib(){
        //Verschiebung aus der Imperfektion des Bauwerks
        double Yimp = 0.0025*Math.sqrt(5.0/Math.max(l12+l23 , l45))*
                      0.5*(1.0+0.7071067812) * Math.max(l12+l23 , l45);

        //Einwirkungen aus den Nullzustnden
        double w1r = -wls0_8;
        double w2r = -wls8_20+wls0_8;
        double w1l = wld0_8;
        double w2l = wld8_20-wld0_8;
        double q34 = gRg-wsog;
        double ws  = wsog;
        eahp = 0;

		//Momente aus dem Null-Zustand
        M210 = M210_e_ah;
        M230 = M230_w_links_Druck;

        M320 = M320_w_links_Druck;
		M340 = M340_g_Rg + M340_w_Sog;

        M430 = M430_g_Rg + M430_w_Sog;
        M450 = M450_w_links_Sog;

        //Fesselkrfte aus dem Null-Zustand
		Z10 = M230-M210;
        Z20 = -M230/l23 + M320/l23 - M450/l45 + (w1r*l45-w1l*l23)*0.5
                                              -  w2l*cl*(8+cl/2.0)/l23
											  +  w2r*cr*(8+cr/2.0)/l45
                                              +  ws*h3;
        Z30 = M340-M320;
        Z40 = M450-M430;

        /**
         * Hier begint die
         * Iteration ber die rechte Seite
         */
        //Deltaschranke fr die Iterationsschritte und der alte Wert
        double delta = 1.0;
		double Yalt = 0.0;
        //Schleife ber die einzelnen Iterationen bis zu einer Abweichung von
        //weniger als 1%
        do{
			Yalt = Y2;
            setCramer();
            Yimp = Y2 >= 0 ? Math.abs(Yimp) : Math.abs(Yimp)*(-1.0);

            //Ntige Schnittkrfte bestimmen
        	double M22 = M210 + M211*Y1;
        	double N12 = M22/b - gStlinks
                        + (w1l*l23*l23*0.5
                           + w2l*(cl*(8+cl*0.5))
                           - w1r*l45*l45*0.5
                           - w2r*(cr*(8+cr*0.5))
                           - ws*(h3*(l23+h3*0.5))
                           - q34*b*b*0.5)/b;
			double N45 = -N12-gStlinks-gStrechts-q34*b;
			//fiktive Krfte
			double f23fikt = N12*(Y2+Yimp)/l23;
			double f45fikt = N45*(Y2+Yimp)/l45;

			//Neue Fesselkraft
        	Z20 = -M230/l23 + M320/l23 - M450/l45 + (w1r*l45-w1l*l23)*0.5
                                              -  w2l*cl*(8+cl/2.0)/l23
											  +  w2r*cr*(8+cr/2.0)/l45
                                              +  ws*h3
 												  + f23fikt + f45fikt;

            delta = (Y2-Yalt)/Yalt;
        }while(delta > 0.001);

        //Schnittkrfte errechnen
		double M34_ = - ws*h3*h3/8
                      + (q34)*b*b/8;
        double M45_ = w2r !=0 && w1r != 0 ?
                        w2r*cr*(cr/2 + (0.5*l45 - w2r+w1r*cr)*(0.5*cr/l45-1))
                      + w1r*0.5*(l45*(0.5*l45 - w2r/w1r*cr) - (0.5*l45 - w2r/w1r*cr)*(0.5*l45 - w2r/w1r*cr)) :
                      0.0;

        double M22 = M210 + M211*Y1;
        double M33 = M320 + M321*Y1 + M322*Y2 + M323*Y3;
        double M44 = M450 +           M452*Y2           + M454*Y4;
		double M34 = M34_ + M33/2.0 + M44/2.0;
        double M45 = w1r != 0.0 ? M45_ + M44/l45*(l45/2.0 + w2r*cr/w1r) :
                                  M45_ + M44/l45*(l45/2.0);

        double N12 = M22/b - gStlinks
                        + (w1l*l23*l23*0.5
                           + w2l*(cl*(8+cl*0.5))
                           - w1r*l45*l45*0.5
                           - w2r*(cr*(8+cr*0.5))
                           - ws*(h3*(l23+h3*0.5))
                           - q34*b*b*0.5)/b;
		double N45 = -N12-gStlinks-gStrechts-q34*b;
        double N43 = Math.cos(rahm.getRiegel().getNeigung())
                      * (M44/l45 - 0.5/l45*(w1r*l45*l45 + w2r*(l45*l45-64)))
                      - Math.sin(rahm.getRiegel().getNeigung())
                      * (N45 + gStrechts);
        double N34 =   N43
                     - Math.cos(rahm.getRiegel().getNeigung())*ws*h3
                     - Math.sin(rahm.getRiegel().getNeigung())*q34*b;

        double Q11  = M22/l12 + eahp*l12/2.0 + eah*l12/3.0;
        double Q22u = Q11 - eahp*l12 - eah*l12/2.0;
        double Q22o = M33/l23 - M22/l23 + w1l*l23/2.0 + w2l*cl*cl/2.0/l23;
        double Q238 = Q22o - w1l*8;
        double Q33u = Q238 - (w1l + w2l)*cl;
        double Q33o =   Q33u * Math.sin(rahm.getRiegel().getNeigung())
                      - (N12+gStlinks)  * Math.cos(rahm.getRiegel().getNeigung());
        double Q44o = Q33o +
                      + ws*h3*Math.sin(rahm.getRiegel().getNeigung())
                      - q34*b*Math.cos(rahm.getRiegel().getNeigung());
        double Q55  = -M44/l45 - w1r*l45/2.0 - w2r*cr*cr/2.0/l45;
        double Q458 = Q55 + w1r*8;
        double Q44u = Q458 + (w1r + w2r)*cr;

        //Ergebnisse in die Vektoren eintragen (sthn)
        rahm.getKeller().setM22(1 , M22);
        rahm.getKeller().setN12(1 , N12);
        rahm.getKeller().setQ11(1 , Q11);
        rahm.getKeller().setQ22u(1 , Q22u);

        rahm.getLinkerStiel().setM22(1 , M22);
        rahm.getLinkerStiel().setM33(1 , M33);
        rahm.getLinkerStiel().setN12(1 , N12);
        rahm.getLinkerStiel().setQ22o(1 , Q22o);
        rahm.getLinkerStiel().setQ238m(1 , Q238);
        rahm.getLinkerStiel().setQ33u(1 , Q33u);

        rahm.getRiegel().setM33(1 , M33);
        rahm.getRiegel().setM34(1 , M34);
        rahm.getRiegel().setM44(1 , M44);
        rahm.getRiegel().setN34(1 , N34);
        rahm.getRiegel().setN43(1 , N43);
        rahm.getRiegel().setQ33o(1 , Q33o);
        rahm.getRiegel().setQ44o(1 , Q44o);

        rahm.getRechterStiel().setM44(1 , M44);
        rahm.getRechterStiel().setM45(1 , M45);
        rahm.getRechterStiel().setN45(1 , N45);
        rahm.getRechterStiel().setQ44u(1 , Q44u);
        rahm.getRechterStiel().setQ458m(1 , Q458);
        rahm.getRechterStiel().setQ55(1 , Q55);

		//Verdrehungen eintragen
		rahm.setY1(1 , Y1);
		rahm.setY2(1 , Y2);
		rahm.setY3(1 , Y3);
		rahm.setY4(1 , Y4);
	}
    /**
     * Grundkombination Ic laut Dokumentation
     */
    private void setGK_Ic(){
        //Verschiebung aus der Imperfektion des Bauwerks
        double Yimp = 0.0025*Math.sqrt(5.0/Math.max(l12+l23 , l45))*
                      0.5*(1.0+0.7071067812) * Math.max(l12+l23 , l45);

        //Einwirkungen aus den Nullzustnden
        double w1r = wrd0_8;
        double w2r = wrd8_20-wrd0_8;
        double w1l = -wrs0_8;
        double w2l = -wrs8_20+wrs0_8;
        double q34 = gRg-wsog;
        double ws  = wsog;
        eahp = 0;

		//Momente aus dem Null-Zustand
        M210 = M210_e_ah;
        M230 = M230_w_rechts_Sog;

        M320 = M320_w_rechts_Sog;
		M340 = M340_g_Rg + M340_w_Sog;

        M430 = M430_g_Rg + M430_w_Sog;
        M450 = M450_w_rechts_Druck;

        //Fesselkrfte aus dem Null-Zustand
		Z10 = M230-M210;
        Z20 = -M230/l23 + M320/l23 - M450/l45 + (w1r*l45-w1l*l23)*0.5
                                              -  w2l*cl*(8+cl/2.0)/l23
											  +  w2r*cr*(8+cr/2.0)/l45
                                              +  ws*h3;
        Z30 = M340-M320;
        Z40 = M450-M430;

        /**
         * Hier begint die
         * Iteration ber die rechte Seite
         */
        //Deltaschranke fr die Iterationsschritte und der alte Wert
        double delta = 1.0;
		double Yalt = 0.0;
        //Schleife ber die einzelnen Iterationen bis zu einer Abweichung von
        //weniger als 1%
        do{
			Yalt = Y2;
            setCramer();
            Yimp = Y2 >= 0 ? Math.abs(Yimp) : Math.abs(Yimp)*(-1.0);

            //Ntige Schnittkrfte bestimmen
        	double M22 = M210 + M211*Y1;
        	double N12 = M22/b - gStlinks
                        + (w1l*l23*l23*0.5
                           + w2l*(cl*(8+cl*0.5))
                           - w1r*l45*l45*0.5
                           - w2r*(cr*(8+cr*0.5))
                           - ws*(h3*(l23+h3*0.5))
                           - q34*b*b*0.5)/b;
			double N45 = -N12-gStlinks-gStrechts-q34*b;
			//fiktive Krfte
			double f23fikt = N12*(Y2+Yimp)/l23;
			double f45fikt = N45*(Y2+Yimp)/l45;

			//Neue Fesselkraft
        	Z20 = -M230/l23 + M320/l23 - M450/l45 + (w1r*l45-w1l*l23)*0.5
                                              -  w2l*cl*(8+cl/2.0)/l23
											  +  w2r*cr*(8+cr/2.0)/l45
                                              +  ws*h3
 												  + f23fikt + f45fikt;

            delta = (Y2-Yalt)/Yalt;
        }while(delta > 0.001);

        //Schnittkrfte errechnen
		double M34_ = - ws*h3*h3/8
                      + (q34)*b*b/8;
        double M45_ = w2r !=0 && w1r != 0 ?
                        w2r*cr*(cr/2 + (0.5*l45 - w2r+w1r*cr)*(0.5*cr/l45-1))
                      + w1r*0.5*(l45*(0.5*l45 - w2r/w1r*cr) - (0.5*l45 - w2r/w1r*cr)*(0.5*l45 - w2r/w1r*cr)) :
                      0.0;

        double M22 = M210 + M211*Y1;
        double M33 = M320 + M321*Y1 + M322*Y2 + M323*Y3;
        double M44 = M450 +           M452*Y2           + M454*Y4;
		double M34 = M34_ + M33/2.0 + M44/2.0;
        double M45 = w1r != 0.0 ? M45_ + M44/l45*(l45/2.0 + w2r*cr/w1r) :
                                  M45_ + M44/l45*(l45/2.0);

        double N12 = M22/b - gStlinks
                        + (w1l*l23*l23*0.5
                           + w2l*(cl*(8+cl*0.5))
                           - w1r*l45*l45*0.5
                           - w2r*(cr*(8+cr*0.5))
                           - ws*(h3*(l23+h3*0.5))
                           - q34*b*b*0.5)/b;
		double N45 = -N12-gStlinks-gStrechts-q34*b;
        double N43 = Math.cos(rahm.getRiegel().getNeigung())
                      * (M44/l45 - 0.5/l45*(w1r*l45*l45 + w2r*(l45*l45-64)))
                      - Math.sin(rahm.getRiegel().getNeigung())
                      * (N45 + gStrechts);
        double N34 =   N43
                     - Math.cos(rahm.getRiegel().getNeigung())*ws*h3
                     - Math.sin(rahm.getRiegel().getNeigung())*q34*b;

        double Q11  = M22/l12 + eahp*l12/2.0 + eah*l12/3.0;
        double Q22u = Q11 - eahp*l12 - eah*l12/2.0;
        double Q22o = M33/l23 - M22/l23 + w1l*l23/2.0 + w2l*cl*cl/2.0/l23;
        double Q238 = Q22o - w1l*8;
        double Q33u = Q238 - (w1l + w2l)*cl;
        double Q33o =   Q33u * Math.sin(rahm.getRiegel().getNeigung())
                      - (N12+gStlinks)  * Math.cos(rahm.getRiegel().getNeigung());
        double Q44o = Q33o +
                      + ws*h3*Math.sin(rahm.getRiegel().getNeigung())
                      - q34*b*Math.cos(rahm.getRiegel().getNeigung());
        double Q55  = -M44/l45 - w1r*l45/2.0 - w2r*cr*cr/2.0/l45;
        double Q458 = Q55 + w1r*8;
        double Q44u = Q458 + (w1r + w2r)*cr;

        //Ergebnisse in die Vektoren eintragen (sthn)
        rahm.getKeller().setM22(2 , M22);
        rahm.getKeller().setN12(2 , N12);
        rahm.getKeller().setQ11(2 , Q11);
        rahm.getKeller().setQ22u(2 , Q22u);

        rahm.getLinkerStiel().setM22(2 , M22);
        rahm.getLinkerStiel().setM33(2 , M33);
        rahm.getLinkerStiel().setN12(2 , N12);
        rahm.getLinkerStiel().setQ22o(2 , Q22o);
        rahm.getLinkerStiel().setQ238m(2 , Q238);
        rahm.getLinkerStiel().setQ33u(2 , Q33u);

        rahm.getRiegel().setM33(2 , M33);
        rahm.getRiegel().setM34(2 , M34);
        rahm.getRiegel().setM44(2 , M44);
        rahm.getRiegel().setN34(2 , N34);
        rahm.getRiegel().setN43(2 , N43);
        rahm.getRiegel().setQ33o(2 , Q33o);
        rahm.getRiegel().setQ44o(2 , Q44o);

        rahm.getRechterStiel().setM44(2 , M44);
        rahm.getRechterStiel().setM45(2 , M45);
        rahm.getRechterStiel().setN45(2 , N45);
        rahm.getRechterStiel().setQ44u(2 , Q44u);
        rahm.getRechterStiel().setQ458m(2 , Q458);
        rahm.getRechterStiel().setQ55(2 , Q55);

		//Verdrehungen eintragen
		rahm.setY1(2 , Y1);
		rahm.setY2(2 , Y2);
		rahm.setY3(2 , Y3);
		rahm.setY4(2 , Y4);
	}
    /**
     * Grundkombination Id laut Dokumentation
     */
    private void setGK_Id(){
        //Verschiebung aus der Imperfektion des Bauwerks
        double Yimp = 0.0025*Math.sqrt(5.0/Math.max(l12+l23 , l45))*
                      0.5*(1.0+0.7071067812) * Math.max(l12+l23 , l45);

        //Einwirkungen aus den Nullzustnden
        double w1r = 0;
        double w2r = 0;
        double w1l = 0;
        double w2l = 0;
        double q34 = gRg;
        double ws  = 0.0;
        eahp = rahm.getErddruck().getPErd(l12);

		//Momente aus dem Null-Zustand
        M210 = M210_e_ah + M210_e_ahp;
        M230 = 0.0;

        M320 = 0.0;
		M340 = M340_g_Rg;

        M430 = M430_g_Rg;
        M450 = 0.0;

        //Fesselkrfte aus dem Null-Zustand
		Z10 = M230-M210;
        Z20 = -M230/l23 + M320/l23 - M450/l45 + (w1r*l45-w1l*l23)*0.5
                                              -  w2l*cl*(8+cl/2.0)/l23
											  +  w2r*cr*(8+cr/2.0)/l45
                                              +  ws*h3;
        Z30 = M340-M320;
        Z40 = M450-M430;

        /**
         * Hier begint die
         * Iteration ber die rechte Seite
         */
        //Deltaschranke fr die Iterationsschritte und der alte Wert
        double delta = 1.0;
		double Yalt = 0.0;
        //Schleife ber die einzelnen Iterationen bis zu einer Abweichung von
        //weniger als 1%
        do{
			Yalt = Y2;
            setCramer();
            Yimp = Y2 >= 0 ? Math.abs(Yimp) : Math.abs(Yimp)*(-1.0);

            //Ntige Schnittkrfte bestimmen
        	double M22 = M210 + M211*Y1;
        	double N12 = M22/b - gStlinks
                        + (w1l*l23*l23*0.5
                           + w2l*(cl*(8+cl*0.5))
                           - w1r*l45*l45*0.5
                           - w2r*(cr*(8+cr*0.5))
                           - ws*(h3*(l23+h3*0.5))
                           - q34*b*b*0.5)/b;
			double N45 = -N12-gStlinks-gStrechts-q34*b;
			//fiktive Krfte
			double f23fikt = N12*(Y2+Yimp)/l23;
			double f45fikt = N45*(Y2+Yimp)/l45;

			//Neue Fesselkraft
        	Z20 = -M230/l23 + M320/l23 - M450/l45 + (w1r*l45-w1l*l23)*0.5
                                              -  w2l*cl*(8+cl/2.0)/l23
											  +  w2r*cr*(8+cr/2.0)/l45
                                              +  ws*h3
 												  + f23fikt + f45fikt;

            delta = (Y2-Yalt)/Yalt;
        }while(delta > 0.001);

        //Schnittkrfte errechnen
		double M34_ = - ws*h3*h3/8
                      + (q34)*b*b/8;
        double M45_ = w2r !=0 && w1r != 0 ?
                        w2r*cr*(cr/2 + (0.5*l45 - w2r+w1r*cr)*(0.5*cr/l45-1))
                      + w1r*0.5*(l45*(0.5*l45 - w2r/w1r*cr) - (0.5*l45 - w2r/w1r*cr)*(0.5*l45 - w2r/w1r*cr)) :
                      0.0;

        double M22 = M210 + M211*Y1;
        double M33 = M320 + M321*Y1 + M322*Y2 + M323*Y3;
        double M44 = M450 +           M452*Y2           + M454*Y4;
		double M34 = M34_ + M33/2.0 + M44/2.0;
        double M45 = w1r != 0.0 ? M45_ + M44/l45*(l45/2.0 + w2r*cr/w1r) :
                                  M45_ + M44/l45*(l45/2.0);

        double N12 = M22/b - gStlinks
                        + (w1l*l23*l23*0.5
                           + w2l*(cl*(8+cl*0.5))
                           - w1r*l45*l45*0.5
                           - w2r*(cr*(8+cr*0.5))
                           - ws*(h3*(l23+h3*0.5))
                           - q34*b*b*0.5)/b;
		double N45 = -N12-gStlinks-gStrechts-q34*b;
        double N43 = Math.cos(rahm.getRiegel().getNeigung())
                      * (M44/l45 - 0.5/l45*(w1r*l45*l45 + w2r*(l45*l45-64)))
                      - Math.sin(rahm.getRiegel().getNeigung())
                      * (N45 + gStrechts);
        double N34 =   N43
                     - Math.cos(rahm.getRiegel().getNeigung())*ws*h3
                     - Math.sin(rahm.getRiegel().getNeigung())*q34*b;

        double Q11  = M22/l12 + eahp*l12/2.0 + eah*l12/3.0;
        double Q22u = Q11 - eahp*l12 - eah*l12/2.0;
        double Q22o = M33/l23 - M22/l23 + w1l*l23/2.0 + w2l*cl*cl/2.0/l23;
        double Q238 = Q22o - w1l*8;
        double Q33u = Q238 - (w1l + w2l)*cl;
        double Q33o =   Q33u * Math.sin(rahm.getRiegel().getNeigung())
                      - (N12+gStlinks)  * Math.cos(rahm.getRiegel().getNeigung());
        double Q44o = Q33o +
                      + ws*h3*Math.sin(rahm.getRiegel().getNeigung())
                      - q34*b*Math.cos(rahm.getRiegel().getNeigung());
        double Q55  = -M44/l45 - w1r*l45/2.0 - w2r*cr*cr/2.0/l45;
        double Q458 = Q55 + w1r*8;
        double Q44u = Q458 + (w1r + w2r)*cr;

        //Ergebnisse in die Vektoren eintragen (sthn)
        rahm.getKeller().setM22(3 , M22);
        rahm.getKeller().setN12(3 , N12);
        rahm.getKeller().setQ11(3 , Q11);
        rahm.getKeller().setQ22u(3 , Q22u);

        rahm.getLinkerStiel().setM22(3 , M22);
        rahm.getLinkerStiel().setM33(3 , M33);
        rahm.getLinkerStiel().setN12(3 , N12);
        rahm.getLinkerStiel().setQ22o(3 , Q22o);
        rahm.getLinkerStiel().setQ238m(3 , Q238);
        rahm.getLinkerStiel().setQ33u(3 , Q33u);

        rahm.getRiegel().setM33(3 , M33);
        rahm.getRiegel().setM34(3 , M34);
        rahm.getRiegel().setM44(3 , M44);
        rahm.getRiegel().setN34(3 , N34);
        rahm.getRiegel().setN43(3 , N43);
        rahm.getRiegel().setQ33o(3 , Q33o);
        rahm.getRiegel().setQ44o(3 , Q44o);

        rahm.getRechterStiel().setM44(3 , M44);
        rahm.getRechterStiel().setM45(3 , M45);
        rahm.getRechterStiel().setN45(3 , N45);
        rahm.getRechterStiel().setQ44u(3 , Q44u);
        rahm.getRechterStiel().setQ458m(3 , Q458);
        rahm.getRechterStiel().setQ55(3 , Q55);

		//Verdrehungen eintragen
		rahm.setY1(3 , Y1);
		rahm.setY2(3 , Y2);
		rahm.setY3(3 , Y3);
		rahm.setY4(3 , Y4);
	}

    /**
     * Grundkombination IIa laut Dokumentation
     */
    private void setGK_IIa(){
        //Verschiebung aus der Imperfektion des Bauwerks
        double Yimp = 0.0025*Math.sqrt(5.0/Math.max(l12+l23 , l45))*
                      0.5*(1.0+0.7071067812) * Math.max(l12+l23 , l45);

        //Einwirkungen aus den Nullzustnden
		gRg = 0.9*gRg;
		sd = 0.9*sd;
        wsog = 0.9*wsog;
        eahp = 0.9*rahm.getErddruck().getPErd(l12);
        eah = 0.9*eah;
        gStlinks = 0.9*gStlinks;
        gStrechts = 0.9*gStrechts;
		wld0_8 = 0.9*wld0_8;
        wld8_20 = 0.9*wld8_20;
        wls0_8 = 0.9*wls0_8;
        wls8_20 = 0.9*wls8_20;
		wrd0_8 = 0.9*wrd0_8;
        wrd8_20 = 0.9*wrd8_20;
        wrs0_8 = 0.9*wrs0_8;
        wrs8_20 = 0.9*wrs8_20;
        double w1r = -wls0_8;
        double w2r = -wls8_20+wls0_8;
        double w1l = wld0_8;
        double w2l = wld8_20-wld0_8;
        double q34 = gRg+sd-wsog;
        double ws  = wsog;



		//Momente aus dem Null-Zustand
        M210 = 0.9*(M210_e_ah + M210_e_ahp);
        M230 = 0.9*(M230_w_links_Druck);

        M320 = 0.9*(M320_w_links_Druck);
		M340 = 0.9*(M340_g_Rg + M340_s + M340_w_Sog);

        M430 = 0.9*(M430_g_Rg + M430_s + M430_w_Sog);
        M450 = 0.9*(M450_w_links_Sog);

        //Fesselkrfte aus dem Null-Zustand
		Z10 = M230-M210;
        Z20 = -M230/l23 + M320/l23 - M450/l45 + (w1r*l45-w1l*l23)*0.5
                                              -  w2l*cl*(8+cl/2.0)/l23
											  +  w2r*cr*(8+cr/2.0)/l45
                                              +  ws*h3;
        Z30 = M340-M320;
        Z40 = M450-M430;

        /**
         * Hier begint die
         * Iteration ber die rechte Seite
         */
        //Deltaschranke fr die Iterationsschritte und der alte Wert
        double delta = 1.0;
		double Yalt = 0.0;
        //Schleife ber die einzelnen Iterationen bis zu einer Abweichung von
        //weniger als 1%
        do{
			Yalt = Y2;
            setCramer();
            Yimp = Y2 >= 0 ? Math.abs(Yimp) : Math.abs(Yimp)*(-1.0);

            //Ntige Schnittkrfte bestimmen
        	double M22 = M210 + M211*Y1;
        	double N12 = M22/b - gStlinks
                        + (w1l*l23*l23*0.5
                           + w2l*(cl*(8+cl*0.5))
                           - w1r*l45*l45*0.5
                           - w2r*(cr*(8+cr*0.5))
                           - ws*(h3*(l23+h3*0.5))
                           - q34*b*b*0.5)/b;
			double N45 = -N12-gStlinks-gStrechts-q34*b;
			//fiktive Krfte
			double f23fikt = N12*(Y2+Yimp)/l23;
			double f45fikt = N45*(Y2+Yimp)/l45;

			//Neue Fesselkraft
        	Z20 = -M230/l23 + M320/l23 - M450/l45 + (w1r*l45-w1l*l23)*0.5
                                              -  w2l*cl*(8+cl/2.0)/l23
											  +  w2r*cr*(8+cr/2.0)/l45
                                              +  ws*h3
 												  + f23fikt + f45fikt;

            delta = (Y2-Yalt)/Yalt;
        }while(delta > 0.001);

        //Schnittkrfte errechnen
		double M34_ = - ws*h3*h3/8
                      + (q34)*b*b/8;
        double M45_ = w2r !=0 && w1r != 0 ?
                        w2r*cr*(cr/2 + (0.5*l45 - w2r+w1r*cr)*(0.5*cr/l45-1))
                      + w1r*0.5*(l45*(0.5*l45 - w2r/w1r*cr) - (0.5*l45 - w2r/w1r*cr)*(0.5*l45 - w2r/w1r*cr)) :
                      0.0;

        double M22 = M210 + M211*Y1;
        double M33 = M320 + M321*Y1 + M322*Y2 + M323*Y3;
        double M44 = M450 +           M452*Y2           + M454*Y4;
		double M34 = M34_ + M33/2.0 + M44/2.0;
        double M45 = w1r != 0.0 ? M45_ + M44/l45*(l45/2.0 + w2r*cr/w1r) :
                                  M45_ + M44/l45*(l45/2.0);

        double N12 = M22/b - gStlinks
                        + (w1l*l23*l23*0.5
                           + w2l*(cl*(8+cl*0.5))
                           - w1r*l45*l45*0.5
                           - w2r*(cr*(8+cr*0.5))
                           - ws*h3*(l23+h3*0.5)
                           - q34*b*b*0.5)/b;
		double N45 = -N12-gStlinks-gStrechts-q34*b;
        double N43 = Math.cos(rahm.getRiegel().getNeigung())
                      * (M44/l45 - 0.5/l45*(w1r*l45*l45 + w2r*(l45*l45-64)))
                      - Math.sin(rahm.getRiegel().getNeigung())
                      * (N45 + gStrechts);
        double N34 =   N43
                     - Math.cos(rahm.getRiegel().getNeigung())*ws*h3
                     - Math.sin(rahm.getRiegel().getNeigung())*q34*b;

        double Q11  = M22/l12 + eahp*l12/2.0 + eah*l12/3.0;
        double Q22u = Q11 - eahp*l12 - eah*l12/2.0;
        double Q22o = M33/l23 - M22/l23 + w1l*l23/2.0 + w2l*cl*cl/2.0/l23;
        double Q238 = Q22o - w1l*8;
        double Q33u = Q238 - (w1l + w2l)*cl;
        double Q33o =   Q33u * Math.sin(rahm.getRiegel().getNeigung())
                      - (N12+gStlinks)  * Math.cos(rahm.getRiegel().getNeigung());
        double Q44o = Q33o +
                      + ws*h3*Math.sin(rahm.getRiegel().getNeigung())
                      - q34*b*Math.cos(rahm.getRiegel().getNeigung());
        double Q55  = -M44/l45 - w1r*l45/2.0 - w2r*cr*cr/2.0/l45;
        double Q458 = Q55 + w1r*8;
        double Q44u = Q458 + (w1r + w2r)*cr;

        //Ergebnisse in die Vektoren eintragen (sthn)
        rahm.getKeller().setM22(4 , M22);
        rahm.getKeller().setN12(4 , N12);
        rahm.getKeller().setQ11(4 , Q11);
        rahm.getKeller().setQ22u(4 , Q22u);

        rahm.getLinkerStiel().setM22(4 , M22);
        rahm.getLinkerStiel().setM33(4 , M33);
        rahm.getLinkerStiel().setN12(4 , N12);
        rahm.getLinkerStiel().setQ22o(4 , Q22o);
        rahm.getLinkerStiel().setQ238m(4 , Q238);
        rahm.getLinkerStiel().setQ33u(4 , Q33u);

        rahm.getRiegel().setM33(4 , M33);
        rahm.getRiegel().setM34(4 , M34);
        rahm.getRiegel().setM44(4 , M44);
        rahm.getRiegel().setN34(4 , N34);
        rahm.getRiegel().setN43(4 , N43);
        rahm.getRiegel().setQ33o(4 , Q33o);
        rahm.getRiegel().setQ44o(4 , Q44o);

        rahm.getRechterStiel().setM44(4 , M44);
        rahm.getRechterStiel().setM45(4 , M45);
        rahm.getRechterStiel().setN45(4 , N45);
        rahm.getRechterStiel().setQ44u(4 , Q44u);
        rahm.getRechterStiel().setQ458m(4 , Q458);
        rahm.getRechterStiel().setQ55(4 , Q55);

		//Verdrehungen eintragen
		rahm.setY1(4 , Y1);
		rahm.setY2(4 , Y2);
		rahm.setY3(4 , Y3);
		rahm.setY4(4 , Y4);



    }

    /**
     * Grundkombination IIb laut Dokumentation
     */
    private void setGK_IIb(){
        //Verschiebung aus der Imperfektion des Bauwerks
        double Yimp = 0.0025*Math.sqrt(5.0/Math.max(l12+l23 , l45))*
                      0.5*(1.0+0.7071067812) * Math.max(l12+l23 , l45);

        //Einwirkungen aus den Nullzustnden
        double w1r = wrd0_8;
        double w2r = wrd8_20-wrd0_8;
        double w1l = -wrs0_8;
        double w2l = -wrs8_20+wrs0_8;
        double q34 = gRg+sd-wsog;
        double ws  = wsog;



		//Momente aus dem Null-Zustand
        M210 = 0.9*(M210_e_ah + M210_e_ahp);
        M230 = 0.9*(M230_w_rechts_Sog);

        M320 = 0.9*(M320_w_rechts_Sog);
		M340 = 0.9*(M340_g_Rg + M340_s + M340_w_Sog);

        M430 = 0.9*(M430_g_Rg + M430_s + M430_w_Sog);
        M450 = 0.9*(M450_w_rechts_Druck);

        //Fesselkrfte aus dem Null-Zustand
		Z10 = M230-M210;
        Z20 = -M230/l23 + M320/l23 - M450/l45 + (w1r*l45-w1l*l23)*0.5
                                              -  w2l*cl*(8+cl/2.0)/l23
											  +  w2r*cr*(8+cr/2.0)/l45
                                              +  ws*h3;
        Z30 = M340-M320;
        Z40 = M450-M430;

        /**
         * Hier begint die
         * Iteration ber die rechte Seite
         */
        //Deltaschranke fr die Iterationsschritte und der alte Wert
        double delta = 1.0;
		double Yalt = 0.0;
        //Schleife ber die einzelnen Iterationen bis zu einer Abweichung von
        //weniger als 1%
        do{
			Yalt = Y2;
            setCramer();
            Yimp = Y2 >= 0 ? Math.abs(Yimp) : Math.abs(Yimp)*(-1.0);

            //Ntige Schnittkrfte bestimmen
        	double M22 = M210 + M211*Y1;
        	double N12 = M22/b - gStlinks
                        + (w1l*l23*l23*0.5
                           + w2l*(cl*(8+cl*0.5))
                           - w1r*l45*l45*0.5
                           - w2r*(cr*(8+cr*0.5))
                           - ws*(h3*(l23+h3*0.5))
                           - q34*b*b*0.5)/b;
			double N45 = -N12-gStlinks-gStrechts-q34*b;
			//fiktive Krfte
			double f23fikt = N12*(Y2+Yimp)/l23;
			double f45fikt = N45*(Y2+Yimp)/l45;

			//Neue Fesselkraft
        	Z20 = -M230/l23 + M320/l23 - M450/l45 + (w1r*l45-w1l*l23)*0.5
                                              -  w2l*cl*(8+cl/2.0)/l23
											  +  w2r*cr*(8+cr/2.0)/l45
                                              +  ws*h3
 												  + f23fikt + f45fikt;

            delta = (Y2-Yalt)/Yalt;
        }while(delta > 0.001);

        //Schnittkrfte errechnen
		double M34_ = - ws*h3*h3/8
                      + (q34)*b*b/8;
        double M45_ = w2r !=0 && w1r != 0 ?
                        w2r*cr*(cr/2 + (0.5*l45 - w2r+w1r*cr)*(0.5*cr/l45-1))
                      + w1r*0.5*(l45*(0.5*l45 - w2r/w1r*cr) - (0.5*l45 - w2r/w1r*cr)*(0.5*l45 - w2r/w1r*cr)) :
                      0.0;

        double M22 = M210 + M211*Y1;
        double M33 = M320 + M321*Y1 + M322*Y2 + M323*Y3;
        double M44 = M450 +           M452*Y2           + M454*Y4;
		double M34 = M34_ + M33/2.0 + M44/2.0;
        double M45 = w1r != 0.0 ? M45_ + M44/l45*(l45/2.0 + w2r*cr/w1r) :
                                  M45_ + M44/l45*(l45/2.0);

        double N12 = M22/b - gStlinks
                        + (w1l*l23*l23*0.5
                           + w2l*(cl*(8+cl*0.5))
                           - w1r*l45*l45*0.5
                           - w2r*(cr*(8+cr*0.5))
                           - ws*(h3*(l23+h3*0.5))
                           - q34*b*b*0.5)/b;
		double N45 = -N12-gStlinks-gStrechts-q34*b;
        double N43 = Math.cos(rahm.getRiegel().getNeigung())
                      * (M44/l45 - 0.5/l45*(w1r*l45*l45 + w2r*(l45*l45-64)))
                      - Math.sin(rahm.getRiegel().getNeigung())
                      * (N45 + gStrechts);
        double N34 =   N43
                     - Math.cos(rahm.getRiegel().getNeigung())*ws*h3
                     - Math.sin(rahm.getRiegel().getNeigung())*q34*b;

        double Q11  = M22/l12 + eahp*l12/2.0 + eah*l12/3.0;
        double Q22u = Q11 - eahp*l12 - eah*l12/2.0;
        double Q22o = M33/l23 - M22/l23 + w1l*l23/2.0 + w2l*cl*cl/2.0/l23;
        double Q238 = Q22o - w1l*8;
        double Q33u = Q238 - (w1l + w2l)*cl;
        double Q33o =   Q33u * Math.sin(rahm.getRiegel().getNeigung())
                      - (N12+gStlinks)  * Math.cos(rahm.getRiegel().getNeigung());
        double Q44o = Q33o +
                      + ws*h3*Math.sin(rahm.getRiegel().getNeigung())
                      - q34*b*Math.cos(rahm.getRiegel().getNeigung());
        double Q55  = -M44/l45 - w1r*l45/2.0 - w2r*cr*cr/2.0/l45;
        double Q458 = Q55 + w1r*8;
        double Q44u = Q458 + (w1r + w2r)*cr;

        //Ergebnisse in die Vektoren eintragen (sthn)
        rahm.getKeller().setM22(5 , M22);
        rahm.getKeller().setN12(5 , N12);
        rahm.getKeller().setQ11(5 , Q11);
        rahm.getKeller().setQ22u(5 , Q22u);

        rahm.getLinkerStiel().setM22(5 , M22);
        rahm.getLinkerStiel().setM33(5 , M33);
        rahm.getLinkerStiel().setN12(5 , N12);
        rahm.getLinkerStiel().setQ22o(5 , Q22o);
        rahm.getLinkerStiel().setQ238m(5 , Q238);
        rahm.getLinkerStiel().setQ33u(5 , Q33u);

        rahm.getRiegel().setM33(5 , M33);
        rahm.getRiegel().setM34(5 , M34);
        rahm.getRiegel().setM44(5 , M44);
        rahm.getRiegel().setN34(5 , N34);
        rahm.getRiegel().setN43(5 , N43);
        rahm.getRiegel().setQ33o(5 , Q33o);
        rahm.getRiegel().setQ44o(5 , Q44o);

        rahm.getRechterStiel().setM44(5 , M44);
        rahm.getRechterStiel().setM45(5 , M45);
        rahm.getRechterStiel().setN45(5 , N45);
        rahm.getRechterStiel().setQ44u(5 , Q44u);
        rahm.getRechterStiel().setQ458m(5 , Q458);
        rahm.getRechterStiel().setQ55(5 , Q55);

		//Verdrehungen eintragen
		rahm.setY1(5 , Y1);
		rahm.setY2(5 , Y2);
		rahm.setY3(5 , Y3);
		rahm.setY4(5 , Y4);
	}
}
