package rahmen;
import java.util.*;

/**Verfeinert die Art des Rahmens. Der linke Stiel ist mit dem Riegel gelenkig verbunden
 */
public final class Rahmen_III extends Rahmen {
  /* {author=Johannes Hhne}*/

    /**
    *   @element-type <{Bauteile}>
    * @stereotype constructor
    */
    Rahmen_III(double h_links, double h_rechts, double breite, double h_keller, double abstand) {
        super(h_links, h_rechts, breite, h_keller, abstand);
    }

    void schneiden() {
        accept(new Schnitt_III());
    }

    void accept(Schnittgroessen visitor){
            visitor.visitRahmen(this);
        }
}
