package rahmen;
import java.util.*;

/**Rechter Stiel
 */
public final class RechterStiel extends Bauteile {
  /* {author=Johannes Hhne}*/

     void setM45(int index, double m45){ this.m45[index] = m45; }

     public double[] getM45(){ return m45; }

     void setM44(int index, double m44){ this.m44[index] = m44; }

     public double[] getM44(){ return m44; }

     public double[] getN45(){ return n45; }

     void setN45(int index, double n45){ this.n45[index] = n45; }

     public double[] getQ44u(){ return q44u; }

     void setQ44u(int index, double q44u){ this.q44u[index] = q44u; }

     public double[] getQ458m(){ return q458m; }

     void setQ458m(int index, double q458m){ this.q458m[index] = q458m; }

     public double[] getQ55(){ return q55; }

     void setQ55(int index, double q55){ this.q55[index] = q55; }

    /**
     * M(44) maximales Moment 
     */
    private double[] m45= new double[6];

    /**
     * M44 Moment oben 
     */
    private double[] m44= new double[6];

    /**
     * N45 
     */
    private double[] n45= new double[6];

    /**
     * Q44u Querkraft oben 
     */
    private double[] q44u= new double[6];

    /**
     * Q458m Querkraft auf 8m Hhe ber Gelndeoberflche 
     */
    private double[] q458m= new double[6];

    /**
     * Q55 Querkraft unten 
     */
    private double[] q55= new double[6];
}
